/***************************************************************************
                          imageprocessing.c  -  description
                             -------------------
    begin                : Mon Apr 12 2004
    copyright            : (C) 2004 by Marco Savegnago IW3FQG
    email                : msave@tin.it

  SVClick is simple program (the my first one on linux...)
  that download camera photo from supervozelj node using
  ax25 stream and convert it to jpeg format.

  Part of the code was from:

  svphoto - Read SuperVozelj photo, and write it in a readable
    jpeg or png format
    Copyright (C) 2001  Paolo Subiaco
    
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include  "svclick.h"
 
void Deinterlace (byte p_imagemap[][XMAX], int i_NumberOfRows, int index)
{
  /*
    deinterlace the photo adding a row between 0 and 1
     index     line read from ccd
     index+1   new line created by deinterlace function
     index+2   line read from ccd
  */

  int i;
  byte  b_x;
  byte* p_0;
  byte* p_1;
  byte* p_2;

  p_0=p_imagemap[index];
  p_1=p_imagemap[index+1];
  p_2=p_imagemap[index+2];

  for (i=0;i<i_NumberOfRows;i++)
  {
    b_x=(*p_0+*p_2)>>1;
    *p_1=(byte)b_x;
    p_0++; p_1++; p_2++;
  }
}

int  ConvertToJPEG(byte p_imagemap[][XMAX], int i_NumberOfRows, int i_NumberOfLines, char* psz_OutFile, int i_Quality)
{
  FILE* f_outfile;
  JSAMPROW  row_pointer[1];
  int y;

  cinfo.err = jpeg_std_error(&jerr);

  jpeg_create_compress(&cinfo);

  if((f_outfile = fopen(psz_OutFile, "wb")) == NULL)
  {
    fprintf(stderr,"Cannot open file %s for write!\n", "OUTFILE");
    jpeg_destroy_compress(&cinfo);

    return 1;
  }

  jpeg_stdio_dest(&cinfo, f_outfile);

  cinfo.image_width       = i_NumberOfRows;
  cinfo.image_height      = i_NumberOfLines;
  cinfo.input_components  = 1;
  cinfo.in_color_space    = JCS_GRAYSCALE;

  jpeg_set_defaults(&cinfo);

  jpeg_set_quality(&cinfo, i_Quality, TRUE);
  cinfo.optimize_coding   = TRUE;

  jpeg_start_compress(&cinfo, TRUE);

  for (y=0;y<i_NumberOfLines;y++)
  {
    row_pointer[0]  = &p_imagemap[y][0];
    (void)jpeg_write_scanlines(&cinfo, row_pointer, 1);
  }

  jpeg_finish_compress(&cinfo);

  fclose(f_outfile);

  jpeg_destroy_compress(&cinfo);

  return  0;
}
